Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 1 | help: |
David Bainbridge | c4029aa | 2019-09-26 18:56:39 +0000 | [diff] [blame] | 2 | @echo "release - build binaries using cross compliing for the support architectures" |
| 3 | @echo "build - build the binary as a local executable" |
| 4 | @echo "install - build and install the binary into \$$GOPATH/bin" |
| 5 | @echo "run - runs voltctl using the command specified as \$$CMD" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 6 | @echo "lint-style - Verify code is properly gofmt-ed" |
| 7 | @echo "lint-sanity - Verify that 'go vet' doesn't report any issues" |
| 8 | @echo "lint-mod - Verify the integrity of the 'mod' files" |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 9 | @echo "lint - run static code analysis" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 10 | @echo "sca - Runs various SCA through golangci-lint tool" |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 11 | @echo "test - run unity tests" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 12 | @echo "check - runs targets that should be run before a commit" |
David Bainbridge | c4029aa | 2019-09-26 18:56:39 +0000 | [diff] [blame] | 13 | @echo "clean - remove temporary and generated files" |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 14 | |
| 15 | internal/pkg/commands/voltha_v1_pb.go: assets/protosets/voltha_v1.pb |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 16 | @echo "/*" > $@ |
| 17 | @echo " * Copyright 2019-present Open Networking Foundation" >> $@ |
| 18 | @echo " *" >> $@ |
| 19 | @echo " * Licensed under the Apache License, Version 2.0 (the "License");" >> $@ |
| 20 | @echo " * you may not use this file except in compliance with the License." >> $@ |
| 21 | @echo " * You may obtain a copy of the License at" >> $@ |
| 22 | @echo " *" >> $@ |
| 23 | @echo " * http://www.apache.org/licenses/LICENSE-2.0" >> $@ |
| 24 | @echo " *" >> $@ |
| 25 | @echo " * Unless required by applicable law or agreed to in writing, software" >> $@ |
| 26 | @echo " * distributed under the License is distributed on an "AS IS" BASIS," >> $@ |
| 27 | @echo " * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied." >> $@ |
| 28 | @echo " * See the License for the specific language governing permissions and" >> $@ |
| 29 | @echo " * limitations under the License." >> $@ |
| 30 | @echo " */" >> $@ |
| 31 | @echo "package commands" >> $@ |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 32 | @echo "" >> $@ |
| 33 | @echo "var V1Descriptor = []byte{" >> $@ |
| 34 | hexdump -ve '1/1 "0x%02x,"' assets/protosets/voltha_v1.pb | fold -w 60 -s >> $@ |
| 35 | @echo "}" >> $@ |
| 36 | @go fmt $@ |
| 37 | |
| 38 | internal/pkg/commands/voltha_v2_pb.go: assets/protosets/voltha_v2.pb |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 39 | @echo "/*" > $@ |
| 40 | @echo " * Copyright 2019-present Open Networking Foundation" >> $@ |
| 41 | @echo " *" >> $@ |
| 42 | @echo " * Licensed under the Apache License, Version 2.0 (the "License");" >> $@ |
| 43 | @echo " * you may not use this file except in compliance with the License." >> $@ |
| 44 | @echo " * You may obtain a copy of the License at" >> $@ |
| 45 | @echo " *" >> $@ |
| 46 | @echo " * http://www.apache.org/licenses/LICENSE-2.0" >> $@ |
| 47 | @echo " *" >> $@ |
| 48 | @echo " * Unless required by applicable law or agreed to in writing, software" >> $@ |
| 49 | @echo " * distributed under the License is distributed on an "AS IS" BASIS," >> $@ |
| 50 | @echo " * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied." >> $@ |
| 51 | @echo " * See the License for the specific language governing permissions and" >> $@ |
| 52 | @echo " * limitations under the License." >> $@ |
| 53 | @echo " */" >> $@ |
| 54 | @echo "package commands" >> $@ |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 55 | @echo "" >> $@ |
| 56 | @echo "var V2Descriptor = []byte{" >> $@ |
| 57 | hexdump -ve '1/1 "0x%02x,"' assets/protosets/voltha_v2.pb | fold -w 60 -s >> $@ |
| 58 | @echo "}" >> $@ |
| 59 | @go fmt $@ |
| 60 | |
| 61 | encode-protosets: internal/pkg/commands/voltha_v1_pb.go internal/pkg/commands/voltha_v2_pb.go |
| 62 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 63 | SHELL=bash -e -o pipefail |
| 64 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 65 | VERSION=$(shell cat ./VERSION) |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 66 | GITCOMMIT=$(shell git rev-parse HEAD) |
| 67 | ifeq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0) |
| 68 | GITDIRTY=false |
| 69 | else |
| 70 | GITDIRTY=true |
| 71 | endif |
| 72 | GOVERSION=$(shell go version 2>&1 | sed -E 's/.*(go[0-9]+\.[0-9]+\.[0-9]+).*/\1/g') |
| 73 | HOST_OS=$(shell uname -s | tr A-Z a-z) |
| 74 | ifeq ($(shell uname -m),x86_64) |
| 75 | HOST_ARCH ?= amd64 |
| 76 | else |
| 77 | HOST_ARCH ?= $(shell uname -m) |
| 78 | endif |
| 79 | BUILDTIME=$(shell date -u +"%Y-%m-%dT%H:%M:%SZ") |
| 80 | |
| 81 | LDFLAGS=-ldflags \ |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 82 | '-X "github.com/opencord/voltctl/internal/pkg/cli/version.Version=$(VERSION)" \ |
| 83 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.VcsRef=$(GITCOMMIT)" \ |
| 84 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.VcsDirty=$(GITDIRTY)" \ |
| 85 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.GoVersion=$(GOVERSION)" \ |
| 86 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.Os=$(HOST_OS)" \ |
| 87 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.Arch=$(HOST_ARCH)" \ |
| 88 | -X "github.com/opencord/voltctl/internal/pkg/cli/version.BuildTime=$(BUILDTIME)"' |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 89 | |
| 90 | # Release related items |
| 91 | # Generates binaries in $RELEASE_DIR with name $RELEASE_NAME-$RELEASE_OS_ARCH |
| 92 | # Inspired by: https://github.com/kubernetes/minikube/releases |
| 93 | RELEASE_DIR ?= release |
| 94 | RELEASE_NAME ?= voltctl |
| 95 | RELEASE_OS_ARCH ?= linux-amd64 windows-amd64 darwin-amd64 |
| 96 | RELEASE_BINS := $(foreach rel,$(RELEASE_OS_ARCH),$(RELEASE_DIR)/$(RELEASE_NAME)-$(subst -dev,_dev,$(VERSION))-$(rel)) |
| 97 | |
| 98 | # Functions to extract the OS/ARCH |
| 99 | rel_ver = $(word 2, $(subst -, ,$(notdir $@))) |
| 100 | rel_os = $(word 3, $(subst -, ,$(notdir $@))) |
| 101 | rel_arch = $(word 4, $(subst -, ,$(notdir $@))) |
| 102 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 103 | # Default is GO111MODULE=auto, which will refuse to use go mod if running |
| 104 | # go less than 1.13.0 and repo is checked out in gopath. For now, force |
| 105 | # module usage. |
| 106 | export GO111MODULE=on |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 107 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 108 | $(RELEASE_BINS): |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 109 | mkdir -p $(RELEASE_DIR) |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 110 | GOOS=$(rel_os) GOARCH=$(rel_arch) \ |
| 111 | go build -mod=vendor -v $(LDFLAGS) -o "$@" cmd/voltctl/voltctl.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 112 | |
| 113 | release: $(RELEASE_BINS) |
| 114 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 115 | build: |
| 116 | go build -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 117 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 118 | install: |
| 119 | go install -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 120 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 121 | run: |
| 122 | go run -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go $(CMD) |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 123 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 124 | lint-style: |
| 125 | ifeq (,$(shell which gofmt)) |
| 126 | go get -u github.com/golang/go/src/cmd/gofmt |
| 127 | endif |
| 128 | @echo -n "Running style check ... " |
| 129 | @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\ |
| 130 | if [ ! -z "$$gofmt_out" ]; then \ |
| 131 | echo "$$gofmt_out" ;\ |
| 132 | echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\ |
| 133 | exit 1 ;\ |
| 134 | fi |
| 135 | @echo "OK" |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 136 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 137 | lint-sanity: |
| 138 | @echo -n "Running sanity check ... " |
| 139 | @go vet -mod=vendor ./... |
| 140 | @echo "OK" |
| 141 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 142 | lint-mod: |
Scott Baker | 4a35a70 | 2019-11-26 08:17:33 -0800 | [diff] [blame] | 143 | go version |
| 144 | @echo "Running dependency check..." |
| 145 | @go mod verify |
| 146 | @echo "Dependency check OK. Running vendor check..." |
| 147 | @git status > /dev/null |
| 148 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1) |
| 149 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1) |
| 150 | go mod tidy |
| 151 | go mod vendor |
| 152 | @git status > /dev/null |
| 153 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 154 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 155 | @echo "Vendor check OK." |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 156 | |
| 157 | lint: lint-style lint-sanity lint-mod |
| 158 | |
| 159 | GOLANGCI_LINT_OUT_FORMAT ?= junit-xml |
| 160 | GOLANGCI_LINT_TOOL:=$(shell which golangci-lint) |
| 161 | sca: |
| 162 | ifeq (,$(GOLANGCI_LINT_TOOL)) |
| 163 | @echo "Please install golangci-lint tool to run sca" |
| 164 | exit 1 |
| 165 | endif |
| 166 | @rm -rf ./sca-report |
| 167 | @mkdir -p ./sca-report |
David Bainbridge | a672234 | 2019-10-24 23:55:53 +0000 | [diff] [blame] | 168 | $(GOLANGCI_LINT_TOOL) run --deadline 20m --out-format $(GOLANGCI_LINT_OUT_FORMAT) ./... 2>&1 | tee ./sca-report/sca-report.xml |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 169 | |
| 170 | test: |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 171 | @mkdir -p ./tests/results |
| 172 | @set +e; \ |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 173 | go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 174 | RETURN=$$? ;\ |
| 175 | go-junit-report < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| 176 | gocover-cobertura < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
| 177 | exit $$RETURN |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 178 | |
| 179 | view-coverage: |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 180 | go tool cover -html ./tests/results/go-test-coverage.out |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 181 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 182 | check: lint sca test |
| 183 | |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 184 | clean: |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 185 | rm -rf voltctl voltctl.cp release sca-report |